#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from glob import glob
from os import path
try:
    from setuptools import setup
except ImportError:
    from distutils.core import setup


install_requires = [
    'pygubu',
    'python-sql',
    'mysql-connector-python-rf',
    ]

extras_require = {
    'PDF':  ['weasyprint', 'lxml'],
    }

py_modules = [
    ]

packages = [
    'scet',
    ]

package_dir = {
    'scet':path.join('src','scet'),
    }

package_data = {
    'scet':[
        path.join('BaseDeDatos', '*.sql'),
        path.join('InterfacesGraficas', '*.ui'),
        path.join('Recursos', '*.png'),
        'entradas.xsl',
        'listado.xsl',
        'estandar.css',
        ]
    }

data_files = [
    ]

scripts = [
    ]

entry_points = {
    'gui_scripts': [
        'scet = scet.main:main',
        ],
    }

classifiers = [
    # How mature is this project? Common values are
    #   3 - Alpha
    #   4 - Beta
    #   5 - Production/Stable
    'Development Status :: 3 - Alpha',

    # Pick your license as you wish (should match "license" above)
     'License :: OSI Approved :: MIT License',

    # Specify the Python versions you support here. In particular, ensure
    # that you indicate whether you support Python 2, Python 3 or both.
    'Programming Language :: Python :: 3',
    'Programming Language :: Python :: 3.3',
    'Programming Language :: Python :: 3.4',
],


setup(
    name = "SCET",
    description='Sistema de Control de Entradas de Taller',
    version = "1.6.5",
    author = "Wolfang Torres",
    author_email = "Wolfang.torres@gmail.com",
    url = "https://bitbucket.org/WolfangT/scet",
    long_description = open('README').read(),
    license='MIT',
    #~ classifiers=classifiers,

    install_requires = install_requires,
    extras_require = extras_require,
    py_modules = py_modules,
    packages = packages,
    package_dir = package_dir,
    package_data = package_data,
    data_files = data_files,
    scripts = scripts,
    entry_points = entry_points,
)
