-- MySQL Script generated by MySQL Workbench
-- mar 08 dic 2015 19:12:55 VET
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema SCET
-- -----------------------------------------------------
DROP SCHEMA IF EXISTS `SCET` ;

-- -----------------------------------------------------
-- Schema SCET
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `SCET` DEFAULT CHARACTER SET utf8 ;
USE `SCET` ;

-- -----------------------------------------------------
-- Table `SCET`.`Objetos`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Objetos` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Objetos` (
  `idObjetos` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `referencia` VARCHAR(50) NULL DEFAULT NULL,
  `nombre` VARCHAR(100) NULL DEFAULT NULL,
  `descripcion` MEDIUMTEXT NULL,
  PRIMARY KEY (`idObjetos`),
  UNIQUE INDEX `referencia_UNIQUE` (`referencia` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Ubicaciones`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Ubicaciones` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Ubicaciones` (
  `idUbicaciones` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `referencia` VARCHAR(50) NULL DEFAULT NULL,
  `nombre` VARCHAR(100) NULL DEFAULT NULL,
  `descripcion` MEDIUMTEXT NULL DEFAULT NULL,
  PRIMARY KEY (`idUbicaciones`),
  UNIQUE INDEX `referencia_UNIQUE` (`referencia` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Entidades`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Entidades` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Entidades` (
  `idEntidades` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `referencia` VARCHAR(50) NULL DEFAULT NULL,
  `nombre` VARCHAR(100) NULL DEFAULT NULL,
  PRIMARY KEY (`idEntidades`),
  UNIQUE INDEX `ref_UNIQUE` (`referencia` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Empresas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Empresas` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Empresas` (
  `idEmpresas` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEntidades` INT UNSIGNED NOT NULL,
  PRIMARY KEY (`idEmpresas`),
  INDEX `fk_Empresas_Entidades_idx` (`idEntidades` ASC),
  CONSTRAINT `fk_Empresas_Entidades`
    FOREIGN KEY (`idEntidades`)
    REFERENCES `SCET`.`Entidades` (`idEntidades`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Talleres`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Talleres` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Talleres` (
  `idTalleres` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idUbicaciones` INT UNSIGNED NOT NULL,
  `idEmpresas` INT UNSIGNED NULL,
  PRIMARY KEY (`idTalleres`),
  INDEX `fk_Talleres_Ubicaciones_idx` (`idUbicaciones` ASC),
  INDEX `fk_Talleres_Empresas_idx` (`idEmpresas` ASC),
  CONSTRAINT `fk_Talleres_Ubicaciones`
    FOREIGN KEY (`idUbicaciones`)
    REFERENCES `SCET`.`Ubicaciones` (`idUbicaciones`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Talleres_Empresas`
    FOREIGN KEY (`idEmpresas`)
    REFERENCES `SCET`.`Empresas` (`idEmpresas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Caracteristicas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Caracteristicas` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Caracteristicas` (
  `idCaracteristicas` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEntidades` INT UNSIGNED NOT NULL,
  `tipo` VARCHAR(50) NOT NULL,
  `valor` MEDIUMTEXT NULL DEFAULT NULL,
  `fecha` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`idCaracteristicas`),
  INDEX `fk_Caracteristicas_Entidades_idx` (`idEntidades` ASC),
  CONSTRAINT `fk_Caracteristicas_Entidades`
    FOREIGN KEY (`idEntidades`)
    REFERENCES `SCET`.`Entidades` (`idEntidades`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Especificaciones`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Especificaciones` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Especificaciones` (
  `idEspecificaciones` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idObjetos` INT UNSIGNED NOT NULL,
  `tipo` VARCHAR(50) NOT NULL,
  `valor` MEDIUMTEXT NULL DEFAULT NULL,
  `fecha` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`idEspecificaciones`),
  INDEX `fk_Caracateristicas_Equipos_idx` (`idObjetos` ASC),
  CONSTRAINT `fk_Caracateristicas_Equipos`
    FOREIGN KEY (`idObjetos`)
    REFERENCES `SCET`.`Objetos` (`idObjetos`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Tecnicos`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Tecnicos` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Tecnicos` (
  `idTecnicos` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEntidades` INT UNSIGNED NOT NULL,
  `idEmpresas` INT UNSIGNED NULL,
  PRIMARY KEY (`idTecnicos`),
  INDEX `fk_Tecnicos_Entidades_idx` (`idEntidades` ASC),
  INDEX `fk_Tecnicos_Empresas_idx` (`idEmpresas` ASC),
  CONSTRAINT `fk_Tecnicos_Entidades`
    FOREIGN KEY (`idEntidades`)
    REFERENCES `SCET`.`Entidades` (`idEntidades`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Tecnicos_Empresas`
    FOREIGN KEY (`idEmpresas`)
    REFERENCES `SCET`.`Empresas` (`idEmpresas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Descripciones`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Descripciones` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Descripciones` (
  `idDescripciones` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idUbicaciones` INT UNSIGNED NOT NULL,
  `tipo` VARCHAR(50) NOT NULL,
  `valor` MEDIUMTEXT NULL,
  `fecha` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`idDescripciones`),
  INDEX `fk_Descripciones_Ubicaciones_idx` (`idUbicaciones` ASC),
  CONSTRAINT `fk_Descripciones_Ubicaciones`
    FOREIGN KEY (`idUbicaciones`)
    REFERENCES `SCET`.`Ubicaciones` (`idUbicaciones`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Almasenes`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Almasenes` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Almasenes` (
  `idAlmasenes` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idUbicaciones` INT UNSIGNED NOT NULL,
  `idEmpresas` INT UNSIGNED NULL,
  PRIMARY KEY (`idAlmasenes`),
  INDEX `fk_Almasenes_Ubicaciones_idx` (`idUbicaciones` ASC),
  INDEX `fk_Almasenes_Empresas_idx` (`idEmpresas` ASC),
  CONSTRAINT `fk_Almasenes_Ubicaciones`
    FOREIGN KEY (`idUbicaciones`)
    REFERENCES `SCET`.`Ubicaciones` (`idUbicaciones`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Almasenes_Empresas`
    FOREIGN KEY (`idEmpresas`)
    REFERENCES `SCET`.`Empresas` (`idEmpresas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Herramientas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Herramientas` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Herramientas` (
  `idHerramientas` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idObjetos` INT UNSIGNED NOT NULL,
  `idEmpresas` INT UNSIGNED NULL,
  PRIMARY KEY (`idHerramientas`),
  INDEX `fk_Herramientas_Equipos_idx` (`idObjetos` ASC),
  INDEX `fk_Herramientas_Empresas_idx` (`idEmpresas` ASC),
  CONSTRAINT `fk_Herramientas_Equipos`
    FOREIGN KEY (`idObjetos`)
    REFERENCES `SCET`.`Objetos` (`idObjetos`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Herramientas_Empresas`
    FOREIGN KEY (`idEmpresas`)
    REFERENCES `SCET`.`Empresas` (`idEmpresas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Clientes`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Clientes` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Clientes` (
  `idClientes` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEntidades` INT UNSIGNED NOT NULL,
  PRIMARY KEY (`idClientes`),
  INDEX `fk_Clientes_Entidades_idx` (`idEntidades` ASC),
  CONSTRAINT `fk_Clientes_Entidades`
    FOREIGN KEY (`idEntidades`)
    REFERENCES `SCET`.`Entidades` (`idEntidades`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Entradas`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Entradas` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Entradas` (
  `idEntradas` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `refenrencia` VARCHAR(50) NULL DEFAULT NULL,
  `idClientes` INT UNSIGNED NOT NULL,
  `idEmpresas` INT UNSIGNED NOT NULL,
  `fecha` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `descripcion` MEDIUMTEXT NULL,
  `estado` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '0: En Proseso\n1: Terminado',
  PRIMARY KEY (`idEntradas`),
  UNIQUE INDEX `refenrencia_UNIQUE` (`refenrencia` ASC),
  INDEX `fk_Entradas_Empresas_idx` (`idEmpresas` ASC),
  INDEX `fk_Entradas_Clientes_idx` (`idClientes` ASC),
  CONSTRAINT `fk_Entradas_Empresas`
    FOREIGN KEY (`idEmpresas`)
    REFERENCES `SCET`.`Empresas` (`idEmpresas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entradas_Clientes`
    FOREIGN KEY (`idClientes`)
    REFERENCES `SCET`.`Clientes` (`idClientes`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Equipos`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Equipos` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Equipos` (
  `idEquipos` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idObjetos` INT UNSIGNED NOT NULL,
  `idClientes` INT UNSIGNED NULL,
  PRIMARY KEY (`idEquipos`),
  INDEX `fk_Equipos_Objetos_idx` (`idObjetos` ASC),
  INDEX `fk_Equipos_Clientes_idx` (`idClientes` ASC),
  CONSTRAINT `fk_Equipos_Objetos`
    FOREIGN KEY (`idObjetos`)
    REFERENCES `SCET`.`Objetos` (`idObjetos`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Equipos_Clientes`
    FOREIGN KEY (`idClientes`)
    REFERENCES `SCET`.`Clientes` (`idClientes`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Trabajos`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Trabajos` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Trabajos` (
  `idTrabajos` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEquipos` INT UNSIGNED NOT NULL,
  `idTalleres` INT UNSIGNED NULL,
  `idAlmasenes` INT UNSIGNED NULL,
  `idEntradas` INT UNSIGNED NOT NULL,
  `fecha` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` TINYINT(1) NOT NULL DEFAULT 0 COMMENT '0: En proceso\n1: Terminado',
  INDEX `fk_Entradas_has_Equipos_Entradas1` (`idEntradas` ASC),
  PRIMARY KEY (`idTrabajos`),
  INDEX `fk_Entrada_Equipos_Talleres_idx` (`idTalleres` ASC),
  INDEX `fk_Entrada_Equipos_Almasenes_idx` (`idAlmasenes` ASC),
  INDEX `fk_Entrada_Equipos_Equipos_idx` (`idEquipos` ASC),
  CONSTRAINT `fk_Entrada_Equipos_Entradas`
    FOREIGN KEY (`idEntradas`)
    REFERENCES `SCET`.`Entradas` (`idEntradas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entrada_Equipos_Talleres`
    FOREIGN KEY (`idTalleres`)
    REFERENCES `SCET`.`Talleres` (`idTalleres`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entrada_Equipos_Almasenes`
    FOREIGN KEY (`idAlmasenes`)
    REFERENCES `SCET`.`Almasenes` (`idAlmasenes`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Entrada_Equipos_Equipos`
    FOREIGN KEY (`idEquipos`)
    REFERENCES `SCET`.`Equipos` (`idEquipos`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Acciones`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Acciones` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Acciones` (
  `idAcciones` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idTecnicos` INT UNSIGNED NULL,
  `idHerramientas` INT UNSIGNED NULL,
  `idTrabajos` INT UNSIGNED NOT NULL,
  `fecha` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `descripcion` MEDIUMTEXT NULL,
  `estado` TINYINT(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (`idAcciones`),
  INDEX `fk_Acciones_Entrada_Equipos1` (`idTrabajos` ASC),
  INDEX `fk_Acciones_Tecnicos_idx` (`idTecnicos` ASC),
  INDEX `fk_Acciones_Herramientas_idx` (`idHerramientas` ASC),
  CONSTRAINT `fk_Acciones_Trabajos`
    FOREIGN KEY (`idTrabajos`)
    REFERENCES `SCET`.`Trabajos` (`idTrabajos`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Acciones_Tecnicos`
    FOREIGN KEY (`idTecnicos`)
    REFERENCES `SCET`.`Tecnicos` (`idTecnicos`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `fk_Acciones_Herramientas`
    FOREIGN KEY (`idHerramientas`)
    REFERENCES `SCET`.`Herramientas` (`idHerramientas`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Contacto`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Contacto` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Contacto` (
  `idContacto` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEntidades` INT UNSIGNED NOT NULL,
  `tipo` VARCHAR(50) NULL,
  `valor` VARCHAR(100) NULL,
  PRIMARY KEY (`idContacto`),
  INDEX `fk_Contacto_Entidades1_idx` (`idEntidades` ASC),
  CONSTRAINT `fk_Contacto_Entidades1`
    FOREIGN KEY (`idEntidades`)
    REFERENCES `SCET`.`Entidades` (`idEntidades`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `SCET`.`Informacion_Fiscal`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `SCET`.`Informacion_Fiscal` ;

CREATE TABLE IF NOT EXISTS `SCET`.`Informacion_Fiscal` (
  `idInformacion_Fiscal` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `idEntidades` INT UNSIGNED NOT NULL,
  `razon_social` VARCHAR(100) NULL,
  `rif_tipo` CHAR(1) NOT NULL,
  `rif_numero` DECIMAL(8,0) NOT NULL,
  `rif_final` DECIMAL(1,0) NULL,
  `estado` VARCHAR(50) NULL,
  `ciudad` VARCHAR(50) NULL,
  `direccion` MEDIUMTEXT NULL,
  PRIMARY KEY (`idInformacion_Fiscal`),
  INDEX `fk_Informacion_fiscal_Entidades1_idx` (`idEntidades` ASC),
  CONSTRAINT `fk_Informacion_fiscal_Entidades1`
    FOREIGN KEY (`idEntidades`)
    REFERENCES `SCET`.`Entidades` (`idEntidades`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

USE `SCET` ;

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Talleres`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Talleres` (`idTalleres` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idEmpresas` INT, `idUbicaciones` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Tecnicos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Tecnicos` (`idTecnicos` INT, `nombre` INT, `referencia` INT, `idEmpresas` INT, `idEntidades` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Almasenes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Almasenes` (`idAlmasenes` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idEmpresas` INT, `idUbicaciones` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Herramientas`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Herramientas` (`idHerramientas` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idEmpresas` INT, `idObjetos` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Clientes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Clientes` (`idClientes` INT, `idEntidades` INT, `nombre` INT, `referencia` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Equipos`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Equipos` (`idEquipos` INT, `idObjetos` INT, `nombre` INT, `referencia` INT, `descripcion` INT, `idClientes` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Empresas`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Empresas` (`idEmpresas` INT, `idEntidades` INT, `nombre` INT, `referencia` INT);

-- -----------------------------------------------------
-- Placeholder table for view `SCET`.`_Entradas`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `SCET`.`_Entradas` (`idEntradas` INT, `idTrabajos` INT, `idEquipos` INT, `idObjetos` INT, `idClientes` INT, `idEntidades` INT, `cliente` INT, `codigo` INT, `equipo` INT, `serial` INT, `descripcion` INT, `entregado` INT, `estado` INT);

-- -----------------------------------------------------
-- function CAPITALISAR
-- -----------------------------------------------------

USE `SCET`;
DROP function IF EXISTS `SCET`.`CAPITALISAR`;

DELIMITER $$
USE `SCET`$$




CREATE FUNCTION CAPITALISAR (input VARCHAR(255))

RETURNS VARCHAR(255)

DETERMINISTIC

BEGIN
	DECLARE len INT;
	DECLARE i INT;

	SET len   = CHAR_LENGTH(input);
	SET input = LOWER(input);
	SET i = 0;

	WHILE (i < len) DO
		IF (MID(input,i,1) = ' ' OR i = 0) THEN
			IF (i < len) THEN
				SET input = CONCAT(
					LEFT(input,i),
					UPPER(MID(input,i + 1,1)),
					RIGHT(input,len - i - 1)
				);
			END IF;
		END IF;
		SET i = i + 1;
	END WHILE;

	RETURN input;
END;$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure CHQ_EXISTENCIA
-- -----------------------------------------------------

USE `SCET`;
DROP procedure IF EXISTS `SCET`.`CHQ_EXISTENCIA`;

DELIMITER $$
USE `SCET`$$




CREATE DEFINER=`root`@`localhost` PROCEDURE `CHQ_EXISTENCIA`(IN TABLA VARCHAR(100), IN COL VARCHAR(100), IN ID INT, INOUT R TINYINT(1))
BEGIN

SET @C = 1;

SET @cmd = CONCAT('SELECT count(*) INTO @C FROM ', TABLA, ' WHERE ', COL, ' = ', ID, ';');
PREPARE proc FROM @cmd;
EXECUTE proc;

IF @C > 0 THEN
    SET R = TRUE;
ELSE
    SET R = FALSE;
END IF;

DEALLOCATE PREPARE proc;

END$$

DELIMITER ;

-- -----------------------------------------------------
-- View `SCET`.`_Talleres`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Talleres` ;
DROP TABLE IF EXISTS `SCET`.`_Talleres`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Talleres` AS
SELECT 
    `a`.`idTalleres`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idEmpresas`,
    `b`.`idUbicaciones`
FROM `Talleres` AS `a` 
LEFT JOIN `Ubicaciones` AS `b` ON (`a`.`idUbicaciones` = `b`.`idUbicaciones`);

-- -----------------------------------------------------
-- View `SCET`.`_Tecnicos`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Tecnicos` ;
DROP TABLE IF EXISTS `SCET`.`_Tecnicos`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Tecnicos` AS
SELECT 
    `a`.`idTecnicos`,
    `b`.`nombre`,
    `b`.`referencia`,
    `a`.`idEmpresas`,
    `b`.`idEntidades`
FROM `Tecnicos` AS `a` 
LEFT JOIN `Entidades` AS `b` ON (`a`.`idEntidades` = `b`.`idEntidades`);

-- -----------------------------------------------------
-- View `SCET`.`_Almasenes`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Almasenes` ;
DROP TABLE IF EXISTS `SCET`.`_Almasenes`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Almasenes` AS
SELECT 
    `a`.`idAlmasenes`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idEmpresas`,
    `b`.`idUbicaciones`
FROM `Almasenes` AS `a` 
LEFT JOIN `Ubicaciones` AS `b` ON (`a`.`idUbicaciones` = `b`.`idUbicaciones`);

-- -----------------------------------------------------
-- View `SCET`.`_Herramientas`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Herramientas` ;
DROP TABLE IF EXISTS `SCET`.`_Herramientas`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Herramientas` AS
SELECT 
    `a`.`idHerramientas`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idEmpresas`,
    `b`.`idObjetos`
FROM `Herramientas` AS `a` 
LEFT JOIN `Objetos` AS `b` ON (`a`.`idObjetos` = `b`.`idObjetos`);

-- -----------------------------------------------------
-- View `SCET`.`_Clientes`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Clientes` ;
DROP TABLE IF EXISTS `SCET`.`_Clientes`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Clientes` AS
SELECT 
    `a`.`idClientes`,
    `b`.`idEntidades`,
    `b`.`nombre`,
    `b`.`referencia`
FROM `Clientes` AS `a` 
LEFT JOIN `Entidades` AS `b` ON (`a`.`idEntidades` = `b`.`idEntidades`);

-- -----------------------------------------------------
-- View `SCET`.`_Equipos`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Equipos` ;
DROP TABLE IF EXISTS `SCET`.`_Equipos`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Equipos` AS
SELECT 
    `a`.`idEquipos`,
    `b`.`idObjetos`,
    `b`.`nombre`,
    `b`.`referencia`,
    `b`.`descripcion`,
    `a`.`idClientes`
FROM `Equipos` AS `a` 
LEFT JOIN `Objetos` AS `b` ON (`a`.`idObjetos` = `b`.`idObjetos`);

-- -----------------------------------------------------
-- View `SCET`.`_Empresas`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Empresas` ;
DROP TABLE IF EXISTS `SCET`.`_Empresas`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Empresas` AS
SELECT 
    `a`.`idEmpresas`,
    `b`.`idEntidades`,
    `b`.`nombre`,
    `b`.`referencia`
FROM `Empresas` AS `a` 
LEFT JOIN `Entidades` AS `b` ON (`a`.`idEntidades` = `b`.`idEntidades`);

-- -----------------------------------------------------
-- View `SCET`.`_Entradas`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `SCET`.`_Entradas` ;
DROP TABLE IF EXISTS `SCET`.`_Entradas`;
USE `SCET`;
CREATE  OR REPLACE VIEW `SCET`.`_Entradas` AS
SELECT
    `a`.`idEntradas`,
    `b`.`idTrabajos`,
    `c`.`idEquipos`,
    `d`.`idObjetos`,
    `e`.`idClientes`,
    `f`.`idEntidades`,
    `f`.`nombre` AS `cliente`,
    `f`.`referencia` AS `codigo`,
    `d`.`nombre`  AS `equipo`,
    `d`.`referencia`  AS `serial`,    
    `d`.`descripcion`,
    `a`.`estado` AS `entregado`, 
    `b`.`estado`
FROM `Entradas` AS `a`
INNER JOIN `Trabajos` AS `b` ON (`a`.`idEntradas` = `b`.`idEntradas`)
INNER JOIN `Equipos` AS `c` ON (`b`.`idEquipos` = `c`.`idEquipos`)
INNER JOIN `Objetos` AS `d` ON (`c`.`idObjetos` = `d`.`idObjetos`)
LEFT JOIN `Clientes` AS `e` ON (`a`.`idClientes` = `e`.`idClientes`)
LEFT JOIN `Entidades` AS `f` ON (`e`.`idEntidades` = `f`.`idEntidades`);
USE `SCET`;

DELIMITER $$

USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Objetos_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Objetos_BINS` BEFORE INSERT ON `Objetos` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.nombre = CAPITALISAR(NEW.nombre);
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Ubicaciones_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Ubicaciones_BINS` BEFORE INSERT ON `Ubicaciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.nombre = CAPITALISAR(NEW.nombre);
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Entidades_BINS` $$
USE `SCET`$$



CREATE TRIGGER `Entidades_BINS` BEFORE INSERT ON `Entidades` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.nombre = CAPITALISAR(NEW.nombre);
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Caracteristicas_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Caracteristicas_BINS` BEFORE INSERT ON `Caracteristicas` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Especificaciones_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Especificaciones_BINS` BEFORE INSERT ON `Especificaciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Descripciones_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Descripciones_BINS` BEFORE INSERT ON `Descripciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Entradas_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Entradas_BINS` BEFORE INSERT ON `Entradas` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
IF NEW.estado = Null THEN
    SET NEW.estado = 0;
END IF;
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Trabajos_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Trabajos_BINS` BEFORE INSERT ON `Trabajos` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
IF NEW.estado = Null THEN
    SET NEW.estado = 0;
END IF;
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Acciones_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Acciones_BINS` BEFORE INSERT ON `Acciones` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.descripcion = CAPITALISAR(NEW.descripcion);
IF NEW.estado = Null THEN
    SET NEW.estado = 0;
END IF;
IF NEW.fecha = 'CURRENT_TIMESTAMP' THEN
    SET NEW.fecha = NOW();
END IF;
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Contacto_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Contacto_BINS` BEFORE INSERT ON `Contacto` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.tipo = CAPITALISAR(NEW.tipo);
END;$$


USE `SCET`$$
DROP TRIGGER IF EXISTS `SCET`.`Informacion_Fiscal_BINS` $$
USE `SCET`$$




CREATE TRIGGER `Informacion_Fiscal_BINS` BEFORE INSERT ON `Informacion_Fiscal` FOR EACH ROW
-- Edit trigger body code below this line. Do not edit lines above this one
BEGIN
SET NEW.razon_social = CAPITALISAR(NEW.razon_social);
SET NEW.estado = CAPITALISAR(NEW.estado);
SET NEW.ciudad = CAPITALISAR(NEW.ciudad);
SET NEW.direccion = CAPITALISAR(NEW.direccion);
SET NEW.rif_tipo = CAPITALISAR(NEW.rif_tipo);
IF NEW.rif_tipo = 'V' THEN
    SET NEW.rif_final = Null;
END IF;
END;$$


DELIMITER ;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
